/*
 * Created on 03-May-2004
 *
 */
package com.jofti.btree;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

/**
 * 
 * This is a special object in the tree and is used to represent an absolute maximum value for a dimension. <br>
 * Class cast issues are taken care of in the Value Object class .<p>
 * 
 * @author Steve Woodcock
 * @version 1.5<br>
 */
public class MaxComparableValue implements Comparable, Externalizable{

	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6357574189849245519L;

	public MaxComparableValue(){
		
	}
	
	public int compareTo(Object o)
	{
		if (o instanceof MaxComparableValue){
			return 0;
		}else{
			return 1;
		}
	}
	
	public boolean equals(Object o){
		if (o instanceof MaxComparableValue){
			return true;
		}
		return false;
	}
	
	public int hashCode(){
		// all has to same value
		return 0;
	}

	/* (non-Javadoc)
	 * @see java.io.Externalizable#readExternal(java.io.ObjectInput)
	 */
	public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
		
		
	}

	/* (non-Javadoc)
	 * @see java.io.Externalizable#writeExternal(java.io.ObjectOutput)
	 */
	public void writeExternal(ObjectOutput out) throws IOException {
		
		
	}
}
