/*
 * Created on 03-May-2004
 *
 */
package com.jofti.btree;

/**
 * 
 * This is a special object in the tree and is used to represent an absolute minimum value for a dimension. <br>
 * Class cast issues are taken care of in the Value Object class .<p>
 * 
 * @author Steve Woodcock
 * @version 1.4<br>
 */
final public class MinComparableValue implements Comparable{

	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	
	public MinComparableValue(){
		
	}
	
	public int compareTo(Object o)
	{
		if (o == this){
			return 0;
		}else{
			return -1;
		}
	}
	
	public boolean equals(Object o){
		if (o instanceof MinComparableValue){
			return true;
		}
		return false;
	}
	
	public int hashCode(){
		// all has to same value
		return 0;
	}
}
